unit ExcelZDataAddin_IMPL;

interface

uses
  SysUtils, ComObj, ComServ, ActiveX, Variants, Office2000, adxAddIn, ExcelZDataAddin_TLB, StdVcl,
  System.Classes;

type
  TcoExcelZDataAddin = class(TadxAddin, IcoExcelZDataAddin)
  protected
    function AddCheck(const Barcode: WideString): OleVariant; safecall;
    function BarcodeEP(const Jahr, Ort, MatGrp, FeldNr, EPNr, Niveau: WideString): OleVariant; safecall;
    function BarcodeMList(const Jahr, Ort, Art, LfdNr: WideString): OleVariant; safecall;
    function BarcodeParz(const Jahr, Ort, MatGrp, FeldNr: WideString): OleVariant; safecall;
    function ClrErr(const Value: OleVariant): OleVariant; safecall;
    function GetPart(const Text, PartNr, Delim, DefaultText: WideString): OleVariant; safecall;
    function GetZEPdata(const BarcodeEP, ColName: WideString): OleVariant; safecall;
    function GetZEPmerkmal(const BarcodeEP, MerkmalAbkz: WideString): OleVariant; safecall;
    function GetZLdata(const BarcodeMList, ColName: WideString): OleVariant; safecall;
    function GetZLmerkmal(const BarcodeMList, MerkmalAbkz: WideString): OleVariant; safecall;
    function GetZPdata(const BarcodeParz, ColName: WideString): OleVariant; safecall;
    function GetZPmerkmal(const BarcodeParz, MerkmalAbkz: WideString): OleVariant; safecall;
    function ParzBarToKurz(const Barcode: WideString): OleVariant; safecall;
    function ParzKurz(const Jahr, Ort, MatGrp, FeldNr: WideString): OleVariant; safecall;
    function ParzKurzToBar(const ParzKurz: WideString): OleVariant; safecall;
  end;

  TZDataAddInModule = class(TadxCOMAddInModule)
    tabTools: TadxRibbonTab;
    procedure tabToolsControls0Controls2Click(Sender: TObject;
      const RibbonControl: IRibbonControl);
    procedure tabToolsControls0Controls1Change(Sender: TObject;
      const RibbonControl: IRibbonControl);
    procedure adxCOMAddInModuleRibbonBeforeCreate(Sender: TObject;
      const RibbonID: WideString);
    procedure adxCOMAddInModuleAddInFinalize(Sender: TObject);
  private
  protected
  public
  end;

implementation

{$R *.dfm}

uses
//  AdoDB, DB,
  Math,
//  CZDataDB,
  UZUtils;

procedure TZDataAddInModule.adxCOMAddInModuleAddInFinalize(Sender: TObject);
begin
//  ZDataModule.Free;
end;

procedure TZDataAddInModule.adxCOMAddInModuleRibbonBeforeCreate(Sender: TObject;
  const RibbonID: WideString);
var
  Sel: Integer;
begin
{
    ZDataModule := TZDataModule.Create(nil);
    Sel := 0;
    try
      if ZDataModule.DB = 'Z2' then
        Sel := 1;
      if ZDataModule.Local then
        Inc(Sel, 2);
    except
    end;
    tabTools.Controls[0].AsRibbonGroup.Controls[1].AsRibbonDropDown.SelectedItemIndex := Sel;

}end;

procedure TZDataAddInModule.tabToolsControls0Controls1Change(Sender: TObject; const RibbonControl: IRibbonControl);
begin
{  case tabTools.Controls[0].AsRibbonGroup.Controls[1].AsRibbonDropDown.SelectedItemIndex of
    0: ZDataModule.ConnectDB(ZDataModule.ADOConnection, 'Z1', False);
    1: ZDataModule.ConnectDB(ZDataModule.ADOConnection, 'Z2', False);
    2: ZDataModule.ConnectDB(ZDataModule.ADOConnection, 'Z1', True);
    3: ZDataModule.ConnectDB(ZDataModule.ADOConnection, 'Z2', True);
  end;
}end;

procedure TZDataAddInModule.tabToolsControls0Controls2Click(Sender: TObject; const RibbonControl: IRibbonControl);
begin // btnNeuLaden
{  ZDataModule.ADOConnection.Connected := False;
  ExcelApp.CalculateFull;
}end;

function TcoExcelZDataAddin.AddCheck(const Barcode: WideString): OleVariant;
var
  Chk, Num          : integer;
  i, l              : integer;
begin
  try
    l := Length(Barcode);
    if not Odd(l) then Dec(l);
    Chk := 0;
    i := l;
    while i > 0 do
    begin
      Num := Ord(Barcode[i]) - Ord('0');
      if (Num < 0) or (Num > 9) then
        raise Exception.Create(_('Invalid Barcode'));
      Chk := Chk + (Ord(Barcode[i]) - Ord('0')) * 3;
      Dec(i);
      if i > 0 then
        Chk := Chk + (Ord(Barcode[i]) - Ord('0'));
      Dec(i);
    end;
    Chk := Chk mod 10;
    if Chk <> 0 then Chk := 10 - Chk;
    Result := Copy(Barcode, 1, l) + char(Chk + Ord('0'));
  except
    on E:Exception do
      Result := '#Err_' + E.Message;
  end;
end;

function TcoExcelZDataAddin.BarcodeEP(const Jahr, Ort, MatGrp, FeldNr, EPNr, Niveau: WideString): OleVariant;
begin
{  try
    Result := AddCheck(Format('%d%.2d%.3d%.3d%.6d%.3d%d', [
      ZDataModule.Frucht,
      StrToIntMinMax(Jahr, _('Year'), 1970, 2069),
      StrToIntMinMax(Ort, _('Location'), 1, 999),
      StrTointMinMax(MatGrp, _('MatGrp'), 1, 999),
      StrToIntMinMax(FeldNr, _('FieldNo'), 1, 999999),
      StrToIntMinMax(EPNr, _('EPNo'), 1, 999),
      StrToIntMinMax(Niveau, _('Niveau'), 0, 9)]));
  except
    on E:Exception do
      Result := '#Err_' + E.Message;
  end;
}end;

function TcoExcelZDataAddin.BarcodeMList(const Jahr, Ort, Art, LfdNr: WideString): OleVariant;
begin
{  try
    Result := AddCheck(Format('%d%.2d%.3d%d%.4d', [
      ZDataModule.Frucht,
      StrToIntMinMax(Jahr, _('Year'), 1970, 2069),
      StrToIntMinMax(Ort, _('Location'), 1, 999),
      StrTointMinMax(Art, _('MList'), 1, 9),
      StrToIntMinMax(LfdNr, _('LfdNo'), 1, 9999)]));
  except
    on E:Exception do
      Result := '#Err_' + E.Message;
  end;
}end;

function TcoExcelZDataAddin.BarcodeParz(const Jahr, Ort, MatGrp, FeldNr: WideString): OleVariant;
begin
{  try
    Result := AddCheck(Format('%d%.2d%.3d%.3d%.6d', [
      ZDataModule.Frucht,
      StrToIntMinMax(Jahr, _('Year'), 1970, 2069),
      StrToIntMinMax(Ort, _('Location'), 1, 999),
      StrTointMinMax(MatGrp, _('MatGrp'), 1, 999),
      StrToIntMinMax(FeldNr, _('FieldNo'), 1, 999999)]));
  except
    on E:Exception do
      Result := '#Err_' + E.Message;
  end;
}end;

function TcoExcelZDataAddin.ClrErr(const Value: OleVariant): OleVariant;
begin
  Result := '';
  if (VarType(Value) <> varError) and (Pos('#', Value) <> 1) then
    Result := Value;
end;

function TcoExcelZDataAddin.GetPart(const Text, PartNr, Delim, DefaultText: WideString): OleVariant;
var
  ADelim: string;
begin
  ADelim := Delim;
  if StrToIntDef(ADelim, 0) > 0 then
    ADelim := Char(StrToIntDef(ADelim, 0));
  Result := ParseStr(Text, StrToIntDef(PartNr, 999), ADelim, DefaultText);
end;

function TcoExcelZDataAddin.GetZEPdata(const BarcodeEP, ColName: WideString): OleVariant;
begin
{  with ZDataModule, ProcGetZEPdata do
  begin
    ConnectDB;
    if Parameters[1].Value <> BarcodeEP then
    begin
      Close;
      Parameters[1].Value := BarcodeEP;
    end;
    try
      Open;
      if RecordCount = 0 then
        raise Exception.Create(Name + ': ' + 'BarcodeEP ''' + BarcodeEP + ''' not found');
      Result := FieldByName(ColName).Value;
    except
      on E: Exception do
        Result := '#Err_' + E.Message;
    end;
  end;
}end;

function TcoExcelZDataAddin.GetZEPmerkmal(const BarcodeEP, MerkmalAbkz: WideString): OleVariant;
begin
{  with ZDataModule, ProcGetZEPmerkmal do
  begin
    ConnectDB;
    if (Parameters[1].Value <> BarcodeEP) or (Parameters[2].Value <> MerkmalAbkz) then
    begin
      Close;
      Parameters[1].Value := BarcodeEP;
      Parameters[2].Value := MerkmalAbkz;
    end;
    try
      Open;
      if RecordCount = 0 then
        raise Exception.Create(Name + ': ' + 'BarcodeEP ''' + BarcodeEP + ''', ''' + MerkmalAbkz + ''' not found');
      Result := Fields[0].Value;
    except
      on E: Exception do
        Result := '#Err_' + E.Message;
    end;
  end;
}end;

function TcoExcelZDataAddin.GetZLdata(const BarcodeMList, ColName: WideString): OleVariant;
begin
{  with ZDataModule, ProcGetZLdata do
  begin
    ConnectDB;
    if Parameters[1].Value <> BarcodeMList then
    begin
      Close;
      Parameters[1].Value := BarcodeMList;
    end;
    try
      Open;
      if RecordCount = 0 then
        raise Exception.Create(Name + ': ' + 'BarcodeMList ''' + BarcodeMList + ''' not found');
      Result := FieldByName(ColName).Value;
    except
      on E: Exception do
        Result := '#Err_' + E.Message;
    end;
  end;
}end;

function TcoExcelZDataAddin.GetZLmerkmal(const BarcodeMList, MerkmalAbkz: WideString): OleVariant;
begin
{  with ZDataModule, ProcGetZLmerkmal do
  begin
    ConnectDB;
    if (Parameters[1].Value <> BarcodeMList) or (Parameters[2].Value <> MerkmalAbkz) then
    begin
      Close;
      Parameters[1].Value := BarcodeMList;
      Parameters[2].Value := MerkmalAbkz;
    end;
    try
      Open;
      if RecordCount = 0 then
        raise Exception.Create(Name + ': ' + 'BarcodeMList ''' + BarcodeMList + ''', ''' + MerkmalAbkz + ''' not found');
      Result := Fields[0].Value;
    except
      on E: Exception do
        Result := '#Err_' + E.Message;
    end;
  end;
}end;

function TcoExcelZDataAddin.GetZPdata(const BarcodeParz, ColName: WideString): OleVariant;
begin
{  with ZDataModule, ProcGetZPdata do
  begin
    ConnectDB;
    if Parameters[1].Value <> BarcodeParz then
    begin
      Close;
      Parameters[1].Value := BarcodeParz;
    end;
    try
      Open;
      if RecordCount = 0 then
        raise Exception.Create(Name + ': ' + 'BarcodeParz ''' + BarcodeParz + ''' not found');
      Result := FieldByName(ColName).Value;
    except
      on E: Exception do
        Result := '#Err_' + E.Message;
    end;
  end;
}end;

function TcoExcelZDataAddin.GetZPmerkmal(const BarcodeParz, MerkmalAbkz: WideString): OleVariant;
begin
{  with ZDataModule, ProcGetZPmerkmal do
  begin
    ConnectDB;
    if (Parameters[1].Value <> BarcodeParz) or (Parameters[2].Value <> MerkmalAbkz) then
    begin
      Close;
      Parameters[1].Value := BarcodeParz;
      Parameters[2].Value := MerkmalAbkz;
    end;
    try
      Open;
      if RecordCount = 0 then
        raise Exception.Create(Name + ': ' + 'BarcodeParz ''' + BarcodeParz + ''', ''' + MerkmalAbkz + ''' not found');
      Result := Fields[0].Value;
    except
      on E: Exception do
        Result := '#Err_' + E.Message;
    end;
  end;
}end;

function TcoExcelZDataAddin.ParzBarToKurz(const Barcode: WideString): OleVariant;
var
//  Frucht: integer;
  Jahr: integer;
  Ort: integer;
  MatGrp: integer;
  FeldNr: integer;
begin
  try
    StrToIntMinMax(Copy(Barcode, 1, 1), _('Crop'), 1, 9);
    Jahr := 1900 + StrToIntMinMax(Copy(Barcode, 2, 2), _('Year'), 0, 99);
    if Jahr < 1970 then Jahr := Jahr + 100;
    Ort := StrToIntMinMax(Copy(Barcode, 4, 3), _('Location'), 1, 999);
    MatGrp := StrToIntMinMax(Copy(Barcode, 7, 3), _('MatGrp'), 1, 999);
    FeldNr := StrToIntMinMax(Copy(Barcode, 10, 6), _('FieldNo'), 1, 999999);
    Result := Format('%.2d|%d|%d-%d', [Jahr mod 100, Ort, MatGrp, FeldNr]);
  except
    on E: Exception do
      raise Exception.Create('#Err_' + Format(_('Invalid Barcode ''%s'' (%s)'), [Barcode, E.Message]));
  end;
end;

function TcoExcelZDataAddin.ParzKurz(const Jahr, Ort, MatGrp, FeldNr: WideString): OleVariant;
begin
  try
    Result := Format('%.2d|%d|%d-%d', [
      StrToIntMinMax(Jahr, _('Year'), 1970, 2069) mod 100,
      StrToIntMinMax(Ort, _('Location'), 1, 999),
      StrTointMinMax(MatGrp, _('MatGrp'), 1, 999),
      StrToIntMinMax(FeldNr, _('FieldNo'), 1, 999999)]);
  except
    on E:Exception do
      Result := '#Err_' + E.Message;
  end;
end;

function TcoExcelZDataAddin.ParzKurzToBar(const ParzKurz: WideString): OleVariant;
var
  Jahr: integer;
begin
  Jahr := ParseInteger(ParzKurz, 1, '|', 999);
  Jahr := Jahr + IfThen(Jahr < 70, 2000, 1900);
  Result := BarcodeParz(IntToStr(Jahr),
    Parse(ParzKurz, 2, '|'),
    Parse(Parse(ParzKurz, 3, '|'), 1, '-'),
    Parse(ParzKurz, 2, '-'));
end;

initialization
  TadxFactory.Create(ComServer, TcoExcelZDataAddin, CLASS_coExcelZDataAddin, TZDataAddInModule);

end.
